# Daniel Twellmann 2015

# First we pull in the standard API hooks.
require 'sketchup.rb'

# Show the Ruby Console at startup so we can
# see any programming errors we may make.
SKETCHUP_CONSOLE.show

# Add a menu item to launch our plugin.
UI.menu("Plugins").add_item("Hornresp") {
  

  # Call our new method.
  draw_horn
}

def draw_horn

 prompts = ["Number of segments"]
 defaults = ["3"]
 inputs = UI.inputbox(prompts, defaults, "Input number of horn segments")
 number_segments = inputs[0].to_i

petals = '0'
small_radius = '10'
large_radius = '20'
segment_length = '100'
temp = 0
for step in 1..number_segments
  
 # With three params, it shows all text boxes:
 prompts = ["Number of petals","Throat radius [cm]", "Mouth radius [cm]", "Segment length [cm]","Previous length [cm]"]

    if step < 2
         defaults = ["12","10", "20", "100",""]
         
    else 
        defaults[0] = petals.to_s
        defaults[1] = large_radius.to_s
        defaults[2] = large_radius.to_s
        defaults[3] = segment_length.to_s
        defaults[4] = temp.to_s
      
    end
 inputs = UI.inputbox(prompts, defaults, "Input data for horn segment")
	petals = inputs[0].to_i
	small_radius = inputs[1].to_f
	large_radius = inputs[2].to_f
	segment_length = inputs[3].to_f
	previous_length = inputs[4].to_f
	
  # Create some variables.
	phi = 2*1*Math::PI/petals
	#phi = 360/petals

for step in 1..petals

  # Get handles to our model and the Entities collection it contains.
  model = Sketchup.active_model
  entities = model.entities

  # Define points
    x1 = Math::cos(phi*(step-1))*small_radius.cm
    x2 = Math::cos(phi*step)*small_radius.cm
    x3 = Math::cos(phi*step)*large_radius.cm
    x4 = Math::cos(phi*(step-1))*large_radius.cm
    
    y1 = Math::sin(phi*(step-1))*small_radius.cm 
    y2 = Math::sin(phi*step)*small_radius.cm
    y3 = Math::sin(phi*step)*large_radius.cm
    y4 = Math::sin(phi*(step-1))*large_radius.cm
    
    z1 = previous_length.cm
    z2 = previous_length.cm
    z3 = segment_length.cm+previous_length.cm
    z4 = segment_length.cm+previous_length.cm
    
	pT1 = [ x1 , y1 , z1 ]
	pT2 = [ x2 , y2 , z2 ]
	pT3 = [ x3 , y3 , z3 ]
	pT4 = [ x4 , y4 , z4 ]


  new_face = entities.add_face pT1, pT2, pT3, pT4

end
temp = temp + segment_length
end
UI.messagebox("Total axial length is: " + temp.to_s + ' cm')
end
